<html>
<head>
<title>OgreD3D9Texture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_c7ffc14721c8bed1493f4f78ca8c7331.html">Direct3D9</a>      </li>
      <li class="navelem"><a class="el" href="dir_1208738e8444befc5f502320df40a1ea.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D9Texture.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D9Texture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D9TEXTURE_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D9TEXTURE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Prerequisites_8h.html">OgreD3D9Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderTexture_8h.html">OgreRenderTexture.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreImage_8h.html">OgreImage.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreException_8h.html">OgreException.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9HardwarePixelBuffer_8h.html">OgreD3D9HardwarePixelBuffer.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D9Resource_8h.html">OgreD3D9Resource.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a><a class="code" href="classOgre_1_1D3D9Texture.html">00040</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D9Resource.html" title="Represents a Direct3D rendering resource.">D3D9Resource</a>
<a name="l00041"></a>00041     {
<a name="l00042"></a>00042     <span class="keyword">protected</span>:  
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html">00044</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html">TextureResources</a>
<a name="l00045"></a>00045         {
<a name="l00047"></a><a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a2c85faa4aeb427de8f5c6f94f3ef00fa">00047</a>             IDirect3DTexture9* <a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a2c85faa4aeb427de8f5c6f94f3ef00fa" title="1D/2D normal texture pointer">pNormTex</a>;    
<a name="l00049"></a><a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a411bbfee5d2b2a843b862e0780736d5c">00049</a>             IDirect3DCubeTexture9* <a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a411bbfee5d2b2a843b862e0780736d5c" title="cubic texture pointer">pCubeTex</a>;    
<a name="l00051"></a><a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a7d81fcdee9b83c7d0fd0e6ab1cc8e344">00051</a>             IDirect3DVolumeTexture9* <a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a7d81fcdee9b83c7d0fd0e6ab1cc8e344" title="Volume texture.">pVolumeTex</a>;
<a name="l00053"></a><a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#af80358bf8d3817fb2fb2ef57dfb5deba">00053</a>             IDirect3DBaseTexture9* <a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#af80358bf8d3817fb2fb2ef57dfb5deba" title="actual texture pointer">pBaseTex</a>;
<a name="l00055"></a><a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a7fa1f814442a33a87cdcb09081077770">00055</a>             IDirect3DSurface9* <a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html#a7fa1f814442a33a87cdcb09081077770" title="Optional FSAA surface.">pFSAASurface</a>;            
<a name="l00056"></a>00056         };
<a name="l00057"></a>00057         
<a name="l00058"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a54212076a9e9d9cdac3cb59bd0df6928">00058</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;IDirect3DDevice9*, TextureResources*&gt;::type</a> <a class="code" href="classOgre_1_1D3D9Texture.html#a54212076a9e9d9cdac3cb59bd0df6928">DeviceToTextureResourcesMap</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a1a3de2b917f876746c987e18dd5bb990">00059</a>         <span class="keyword">typedef</span> DeviceToTextureResourcesMap::iterator           <a class="code" href="classOgre_1_1D3D9Texture.html#a1a3de2b917f876746c987e18dd5bb990">DeviceToTextureResourcesIterator</a>;
<a name="l00060"></a>00060 
<a name="l00062"></a><a class="code" href="classOgre_1_1D3D9Texture.html#aae859d7cf1c515daf414f9d1ddda6198">00062</a>         <a class="code" href="classOgre_1_1D3D9Texture.html#a54212076a9e9d9cdac3cb59bd0df6928">DeviceToTextureResourcesMap</a> <a class="code" href="classOgre_1_1D3D9Texture.html#aae859d7cf1c515daf414f9d1ddda6198" title="Map between device to texture resources.">mMapDeviceToTextureResources</a>;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00066"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a4d63cdb2569ff62a6c73dbf8b7967c0a">00066</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;HardwarePixelBufferSharedPtr&gt;::type</a> <a class="code" href="classOgre_1_1D3D9Texture.html#a4d63cdb2569ff62a6c73dbf8b7967c0a" title="Vector of pointers to subsurfaces.">SurfaceList</a>;
<a name="l00067"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a9eaddf9da8fb32bdc773591ac5e0afe9">00067</a>         <a class="code" href="classOgre_1_1D3D9Texture.html#a4d63cdb2569ff62a6c73dbf8b7967c0a" title="Vector of pointers to subsurfaces.">SurfaceList</a> <a class="code" href="classOgre_1_1D3D9Texture.html#a9eaddf9da8fb32bdc773591ac5e0afe9">mSurfaceList</a>;
<a name="l00069"></a><a class="code" href="classOgre_1_1D3D9Texture.html#af72a0cbfa63315cff8fdd1b4bf2e5e98">00069</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>                          mCubeFaceNames[6];  
<a name="l00071"></a><a class="code" href="classOgre_1_1D3D9Texture.html#aff77ee5524980836123f5f6c8a2b407f">00071</a>         D3DPOOL                         <a class="code" href="classOgre_1_1D3D9Texture.html#aff77ee5524980836123f5f6c8a2b407f" title="The memory pool being used.">mD3DPool</a>;
<a name="l00072"></a>00072         <span class="comment">// Dynamic textures?</span>
<a name="l00073"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a2bfe1d88310b466c1a5c538e302fa81f">00073</a>         <span class="keywordtype">bool</span>                            <a class="code" href="classOgre_1_1D3D9Texture.html#a2bfe1d88310b466c1a5c538e302fa81f">mDynamicTextures</a>;
<a name="l00074"></a>00074         
<a name="l00076"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a865aeb1ecf017c2252f006b3abfffeb7">00076</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9Texture.html#a865aeb1ecf017c2252f006b3abfffeb7" title="Is hardware gamma supported (read)?">mHwGammaReadSupported</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1D3D9Texture.html#aab598eb6c303248fb63d16b92d591b08">00078</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9Texture.html#aab598eb6c303248fb63d16b92d591b08" title="Is hardware gamma supported (write)?">mHwGammaWriteSupported</a>;
<a name="l00079"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a6a0eecf8a12662f16ef7d466a5f3144a">00079</a>         D3DMULTISAMPLE_TYPE <a class="code" href="classOgre_1_1D3D9Texture.html#a6a0eecf8a12662f16ef7d466a5f3144a">mFSAAType</a>;
<a name="l00080"></a><a class="code" href="classOgre_1_1D3D9Texture.html#aeb1ea59125c8965d2d2fdb55206a0a89">00080</a>         DWORD <a class="code" href="classOgre_1_1D3D9Texture.html#aeb1ea59125c8965d2d2fdb55206a0a89">mFSAAQuality</a>;
<a name="l00081"></a>00081         
<a name="l00082"></a>00082         <span class="comment">// needed to store data between prepareImpl and loadImpl</span>
<a name="l00083"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a8eedc86fe33dd505c07a0f141f91c70e">00083</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;vector&lt;MemoryDataStreamPtr&gt;::type</a> &gt; <a class="code" href="classOgre_1_1D3D9Texture.html#a8eedc86fe33dd505c07a0f141f91c70e">LoadedStreams</a>;
<a name="l00084"></a>00084 
<a name="l00086"></a>00086         <span class="keywordtype">void</span> _loadCubeTex(IDirect3DDevice9* d3d9Device, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> &amp;loadedStreams);
<a name="l00088"></a>00088         <span class="keywordtype">void</span> _loadNormTex(IDirect3DDevice9* d3d9Device, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> &amp;loadedStreams);
<a name="l00090"></a>00090         <span class="keywordtype">void</span> _loadVolumeTex(IDirect3DDevice9* d3d9Device, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> &amp;loadedStreams);
<a name="l00091"></a>00091 
<a name="l00093"></a>00093         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> _prepareCubeTex();
<a name="l00095"></a>00095         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> _prepareNormTex();
<a name="l00097"></a>00097         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> _prepareVolumeTex();
<a name="l00098"></a>00098 
<a name="l00100"></a>00100         <span class="keywordtype">void</span> _createNormTex(IDirect3DDevice9* d3d9Device);
<a name="l00102"></a>00102         <span class="keywordtype">void</span> _createCubeTex(IDirect3DDevice9* d3d9Device);
<a name="l00104"></a>00104         <span class="keywordtype">void</span> _createVolumeTex(IDirect3DDevice9* d3d9Device);
<a name="l00105"></a>00105 
<a name="l00107"></a>00107         D3DFORMAT _chooseD3DFormat(IDirect3DDevice9* d3d9Device);
<a name="l00108"></a>00108 
<a name="l00110"></a>00110         <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00112"></a>00112         <span class="keywordtype">void</span> createInternalResources(<span class="keywordtype">void</span>);
<a name="l00114"></a>00114         <span class="keywordtype">void</span> freeInternalResources(<span class="keywordtype">void</span>);
<a name="l00116"></a>00116         <span class="keywordtype">void</span> createInternalResourcesImpl(<span class="keywordtype">void</span>);
<a name="l00118"></a>00118         <span class="keywordtype">void</span> createInternalResourcesImpl(IDirect3DDevice9* d3d9Device);
<a name="l00120"></a>00120         <span class="keywordtype">void</span> freeInternalResourcesImpl(<span class="keywordtype">void</span>);
<a name="l00122"></a>00122         <span class="keywordtype">void</span> _setSrcAttributes(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> height, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> depth, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00124"></a>00124         <span class="keywordtype">void</span> _setFinalAttributes(IDirect3DDevice9* d3d9Device, <a class="code" href="structOgre_1_1D3D9Texture_1_1TextureResources.html">TextureResources</a>* textureResources, 
<a name="l00125"></a>00125             <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> height, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> depth, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00127"></a>00127         D3DTEXTUREFILTERTYPE _getBestFilterMethod(IDirect3DDevice9* d3d9Device);
<a name="l00129"></a>00129         <span class="keywordtype">bool</span> _canUseDynamicTextures(IDirect3DDevice9* d3d9Device, DWORD srcUsage, D3DRESOURCETYPE srcType, D3DFORMAT srcFormat);
<a name="l00131"></a>00131         <span class="keywordtype">bool</span> _canAutoGenMipmaps(IDirect3DDevice9* d3d9Device, DWORD srcUsage, D3DRESOURCETYPE srcType, D3DFORMAT srcFormat);
<a name="l00133"></a>00133         <span class="keywordtype">bool</span> _canUseHardwareGammaCorrection(IDirect3DDevice9* d3d9Device, DWORD srcUsage, D3DRESOURCETYPE srcType, D3DFORMAT srcFormat, <span class="keywordtype">bool</span> forwriting);
<a name="l00134"></a>00134         
<a name="l00136"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a691c263797cf78e4264622e6a403f4af">00136</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> _getCubeFaceName(<span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> face)<span class="keyword"> const</span>
<a name="l00137"></a>00137 <span class="keyword">        </span>{ assert(face &lt; 6); <span class="keywordflow">return</span> mCubeFaceNames[face]; }
<a name="l00138"></a>00138         
<a name="l00141"></a>00141         <span class="keywordtype">void</span> _createSurfaceList(IDirect3DDevice9* d3d9Device, TextureResources* textureResources);
<a name="l00142"></a>00142 
<a name="l00144"></a>00144         <span class="keywordtype">void</span> loadImpl();         
<a name="l00146"></a>00146         <span class="keywordtype">void</span> loadImpl(IDirect3DDevice9* d3d9Device);
<a name="l00148"></a>00148         <span class="keywordtype">void</span> prepareImpl();
<a name="l00150"></a>00150         <span class="keywordtype">void</span> unprepareImpl();
<a name="l00152"></a>00152         <span class="keywordtype">void</span> postLoadImpl();
<a name="l00153"></a>00153 
<a name="l00155"></a>00155         TextureResources* getTextureResources(IDirect3DDevice9* d3d9Device);
<a name="l00156"></a>00156 
<a name="l00158"></a>00158         TextureResources* allocateTextureResources(IDirect3DDevice9* d3d9Device);
<a name="l00159"></a>00159 
<a name="l00161"></a>00161         <span class="keywordtype">void</span> createTextureResources(IDirect3DDevice9* d3d9Device);
<a name="l00162"></a>00162 
<a name="l00164"></a>00164         <span class="keywordtype">void</span> freeTextureResources(IDirect3DDevice9* d3d9Device, TextureResources* textureResources);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         <span class="keywordtype">void</span> determinePool();
<a name="l00167"></a>00167 
<a name="l00172"></a><a class="code" href="classOgre_1_1D3D9Texture.html#ad923ae695661b89e07a9a753a0cafcf9">00172</a>         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedStreams</a> <a class="code" href="classOgre_1_1D3D9Texture.html#ad923ae695661b89e07a9a753a0cafcf9" title="Vector of pointers to streams that were pulled from disk by prepareImpl but have yet to be pushed int...">mLoadedStreams</a>;
<a name="l00173"></a>00173 
<a name="l00174"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a6066bcdcb0bfe3a0d4ab47fbcee00281">00174</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D9HardwarePixelBuffer.html">D3D9HardwarePixelBuffer</a>;
<a name="l00175"></a>00175     <span class="keyword">public</span>:
<a name="l00177"></a>00177         <a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00178"></a>00178             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader);
<a name="l00180"></a>00180         ~<a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>();
<a name="l00181"></a>00181 
<a name="l00183"></a>00183         <span class="keywordtype">void</span> copyToTexture( <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; target );
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> getBuffer(<span class="keywordtype">size_t</span> face, <span class="keywordtype">size_t</span> mipmap);
<a name="l00188"></a>00188         
<a name="l00190"></a>00190         IDirect3DBaseTexture9 *getTexture();        
<a name="l00192"></a>00192         IDirect3DTexture9 *getNormTexture();
<a name="l00194"></a>00194         IDirect3DCubeTexture9 *getCubeTexture();
<a name="l00195"></a>00195 
<a name="l00203"></a><a class="code" href="classOgre_1_1D3D9Texture.html#a5bf22a0ef6330f4ce2d2094453b5d855">00203</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9Texture.html#a5bf22a0ef6330f4ce2d2094453b5d855" title="Indicates whether the hardware gamma is actually enabled and supported.">isHardwareGammaReadToBeUsed</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHwGamma &amp;&amp; mHwGammaReadSupported; }
<a name="l00204"></a>00204                     
<a name="l00206"></a>00206         <span class="keywordtype">bool</span> useDefaultPool();
<a name="l00207"></a>00207 
<a name="l00208"></a>00208         <span class="comment">// Called immediately after the Direct3D device has been created.</span>
<a name="l00209"></a>00209         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceCreate(IDirect3DDevice9* d3d9Device);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211         <span class="comment">// Called before the Direct3D device is going to be destroyed.</span>
<a name="l00212"></a>00212         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceDestroy(IDirect3DDevice9* d3d9Device);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214         <span class="comment">// Called immediately after the Direct3D device has entered a lost state.</span>
<a name="l00215"></a>00215         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceLost(IDirect3DDevice9* d3d9Device);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217         <span class="comment">// Called immediately after the Direct3D device has been reset</span>
<a name="l00218"></a>00218         <span class="keyword">virtual</span> <span class="keywordtype">void</span> notifyOnDeviceReset(IDirect3DDevice9* d3d9Device); 
<a name="l00219"></a>00219     };
<a name="l00220"></a>00220 
<a name="l00227"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html">00227</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9TexturePtr.">D3D9TexturePtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;D3D9Texture&gt; 
<a name="l00228"></a>00228     {
<a name="l00229"></a>00229     <span class="keyword">public</span>:
<a name="l00230"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html#a914bffd35a5e69cf6436591ce1addc92">00230</a>         <a class="code" href="classOgre_1_1D3D9TexturePtr.html#a914bffd35a5e69cf6436591ce1addc92">D3D9TexturePtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>&gt;() {}
<a name="l00231"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html#a83cda12b31cbacfa9030505ac710af1c">00231</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1D3D9TexturePtr.html#a83cda12b31cbacfa9030505ac710af1c">D3D9TexturePtr</a>(<a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>&gt;(rep) {}
<a name="l00232"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html#a5208362b1c1cb37d0d5f5115e4636f26">00232</a>         <a class="code" href="classOgre_1_1D3D9TexturePtr.html#a5208362b1c1cb37d0d5f5115e4636f26">D3D9TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1D3D9TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9TexturePtr.">D3D9TexturePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>&gt;(r) {} 
<a name="l00233"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html#a7f1bd5048db5423223fa01c30cf6e7a8">00233</a>         <a class="code" href="classOgre_1_1D3D9TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9TexturePtr.">D3D9TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>&gt;()
<a name="l00234"></a>00234         {
<a name="l00235"></a>00235             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00236"></a>00236             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00237"></a>00237             {
<a name="l00238"></a>00238                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00239"></a>00239                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00240"></a>00240                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00241"></a>00241                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00242"></a>00242                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00243"></a>00243                 {
<a name="l00244"></a>00244                     ++(*pUseCount);
<a name="l00245"></a>00245                 }
<a name="l00246"></a>00246             }
<a name="l00247"></a>00247         }
<a name="l00248"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html#a698d9138bed34cb468bb207f9bb8800e">00248</a>         <a class="code" href="classOgre_1_1D3D9TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9TexturePtr.">D3D9TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>&gt;()
<a name="l00249"></a>00249         {
<a name="l00250"></a>00250             *<span class="keyword">this</span> = r;
<a name="l00251"></a>00251         }
<a name="l00252"></a>00252 
<a name="l00254"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html#af12a944265bdb775f4b870fefda0136e">00254</a>         <a class="code" href="classOgre_1_1D3D9TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9TexturePtr.">D3D9TexturePtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00255"></a>00255         {
<a name="l00256"></a>00256             <span class="keywordflow">if</span> (pRep == static_cast&lt;D3D9Texture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00257"></a>00257                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00258"></a>00258             release();
<a name="l00259"></a>00259             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00260"></a>00260             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00261"></a>00261             {
<a name="l00262"></a>00262                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00263"></a>00263                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00264"></a>00264                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00265"></a>00265                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00266"></a>00266                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00267"></a>00267                 {
<a name="l00268"></a>00268                     ++(*pUseCount);
<a name="l00269"></a>00269                 }
<a name="l00270"></a>00270             }
<a name="l00271"></a>00271             <span class="keywordflow">else</span>
<a name="l00272"></a>00272             {
<a name="l00273"></a>00273                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00274"></a>00274                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00275"></a>00275                 setNull();
<a name="l00276"></a>00276             }
<a name="l00277"></a>00277             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00278"></a>00278         }
<a name="l00280"></a><a class="code" href="classOgre_1_1D3D9TexturePtr.html#ad21d6252ca96ab4c5555e65eb6740836">00280</a>         <a class="code" href="classOgre_1_1D3D9TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D9TexturePtr.">D3D9TexturePtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; r)
<a name="l00281"></a>00281         {
<a name="l00282"></a>00282             <span class="keywordflow">if</span> (pRep == static_cast&lt;D3D9Texture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00283"></a>00283                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00284"></a>00284             release();
<a name="l00285"></a>00285             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00286"></a>00286             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00287"></a>00287             {
<a name="l00288"></a>00288                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00289"></a>00289                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00290"></a>00290                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D9Texture.html">D3D9Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00291"></a>00291                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00292"></a>00292                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00293"></a>00293                 {
<a name="l00294"></a>00294                     ++(*pUseCount);
<a name="l00295"></a>00295                 }
<a name="l00296"></a>00296             }
<a name="l00297"></a>00297             <span class="keywordflow">else</span>
<a name="l00298"></a>00298             {
<a name="l00299"></a>00299                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00300"></a>00300                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00301"></a>00301                 setNull();
<a name="l00302"></a>00302             }
<a name="l00303"></a>00303             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00304"></a>00304         }
<a name="l00305"></a>00305     };
<a name="l00306"></a>00306 
<a name="l00308"></a><a class="code" href="classOgre_1_1D3D9RenderTexture.html">00308</a>     <span class="keyword">class </span><a class="code" href="OgreD3D9Prerequisites_8h.html#a2f097a9b4c2ebfb75896e7d6eec01a1d">_OgreD3D9Export</a> <a class="code" href="classOgre_1_1D3D9RenderTexture.html" title="RenderTexture implementation for D3D9.">D3D9RenderTexture</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>
<a name="l00309"></a>00309     {
<a name="l00310"></a>00310     <span class="keyword">public</span>:
<a name="l00311"></a>00311         <a class="code" href="classOgre_1_1D3D9RenderTexture.html" title="RenderTexture implementation for D3D9.">D3D9RenderTexture</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <a class="code" href="classOgre_1_1D3D9HardwarePixelBuffer.html">D3D9HardwarePixelBuffer</a> *buffer, <span class="keywordtype">bool</span> writeGamma, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa);
<a name="l00312"></a><a class="code" href="classOgre_1_1D3D9RenderTexture.html#ab6ea8839b07e61ba822c2afdec2607a9">00312</a>         <a class="code" href="classOgre_1_1D3D9RenderTexture.html#ab6ea8839b07e61ba822c2afdec2607a9">~D3D9RenderTexture</a>() {}
<a name="l00313"></a>00313 
<a name="l00314"></a>00314         <span class="keyword">virtual</span> <span class="keywordtype">void</span> update(<span class="keywordtype">bool</span> <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">swap</a>);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getCustomAttribute( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span> *pData );
<a name="l00317"></a>00317 
<a name="l00318"></a><a class="code" href="classOgre_1_1D3D9RenderTexture.html#a59cb0d05c7170c1380d1ab4403314de1">00318</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D9RenderTexture.html#a59cb0d05c7170c1380d1ab4403314de1">requiresTextureFlipping</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00319"></a>00319 
<a name="l00321"></a>00321         <span class="keywordtype">void</span> swapBuffers(<span class="keywordtype">bool</span> waitForVSync = <span class="keyword">true</span>);
<a name="l00322"></a>00322 
<a name="l00323"></a>00323     };
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
